
VE_ANFANG:
    .db 6, "anfang",0 
    .dw VE_HEAD
    .set VE_HEAD = VE_ANFANG 
XT_ANFANG:
    .dw PFA_DOVARIABLE
PFA_ANFANG:
    .dw PFA_ANFANG0
PFA_ANFANG0:
    .dw $5555,$5555,$5555,$5555,$5555 ; starting sequence for idump 

; Arithmetic and Logic Insrtuctions  

     add   r0, r2       ; ( Rd Rr -- ) 
     adc   r0, r2       ; ( Rd Rr -- ) 
     adiw  r25:r24,1    ; ( Rw k6 -- ) 
     sub   r0, r2       ; ( Rd Rr -- ) 
     subi  r16, 1       ; ( Rd k8 -- ) 
     sbc   r0, r2       ; ( Rd Rr -- ) 
     sbci  r16, 1       ; ( Rd k8 -- ) 
     sbiw  r25:r24,1    ; ( Rw k6 -- ) 
     and   r0, r2       ; ( Rd Rr -- ) 
     andi  r16, 1       ; ( Rd k8 -- ) 
     or    r0, r2       ; ( Rd Rr -- ) 
     ori   r16, 1       ; ( Rd k8 -- ) 
     eor   r0, r2       ; ( Rd Rr -- ) 
     com   r0           ; ( Rd --    ) 
     neg   r0           ; ( Rd --    ) 
     sbr   r16, 1       ; ( Rd k8 -- ) 
     cbr   r16, 1       ; ( Rd k8 -- ) 
     inc   r0           ; ( Rd --    ) 
     dec   r0           ; ( Rd --    ) 
     tst   r0           ; ( Rd --    ) 
     clr   r0           ; ( Rd --    ) 
     ser   r16          ; ( Rd --    ) 
     mul    r16, r18    ; ( Rd Rr -- ) 
     muls   r16, r18    ; ( Rd Rr -- ) 
     mulsu  r16, r18    ; ( Rd Rr -- ) 
     fmul   r16, r18    ; ( Rd Rr -- ) 
     fmuls  r16, r18    ; ( Rd Rr -- ) 
     fmulsu r16, r18    ; ( Rd Rr -- ) 

; Branch Instructions 
A0:  rjmp   A1      ; ( k12 --    )  k12 = $FFF = &4095 = 4K 
A1:  ijmp           ; ( -- ) 
;     eijmp          ; ( -- ) 
; k16 = $FFFF ; k6 = 3F max
; together: $3FFFFF = &4194303 = 4MB 
     jmp    $3FFFFF ; ( k16 k6 -- ) 
     rcall  A2      ; ( k12 --    )  k12 = $FFF = &4095 = 4K 
A2:     nop         ; dummy for rcall 
     icall          ; ( -- ) 
;     eicall         ; ( -- ) 
     call   $3FFFFF ; ( k16 k6 -- ) 
     ret            ; ( -- ) 
     reti           ; ( -- ) 
     cpse  r0, r2   ; ( Rd Rr -- ) 
     cp    r0, r2   ; ( Rd Rr -- ) 
     cpc   r0, r2   ; ( Rd Rr -- ) 
     cpi   r16, 1   ; ( Rd k8 -- ) 
     sbrc  r0,7     ; ( Rd b --  ) 
     sbrs  r0,7     ; ( Rd b --  ) 
     sbic  $1C, 1   ; ( P b --   ) 
     sbis  $1C, 1   ; ( P b --   ) 
A3:     nop
; k7 = %1111111 = $7F max = &127 
; opcode: 1111 01kk kkkk kbbb ; k=offset to PC, bbb=bit0..7 

A4:  brbs  1, A5    ; ( b k7 --  )
A5:  brbc  1, A6    ; ( b k7 --  ) 
A6:     nop 
A7:  breq A8        ; ( k7 -- ) 
A8:  brne A9        ; ( k7 -- ) 
A9:  brcs A10       ; ( k7 -- ) 
A10: brcc A11       ; ( k7 -- ) 
A11: brsh A12       ; ( k7 -- ) 
A12: brlo A13       ; ( k7 -- ) 
A13: brmi A14       ; ( k7 -- ) 
A14: brpl A15       ; ( k7 -- ) 
A15: brge A16       ; ( k7 -- ) 
A16: brlt A17       ; ( k7 -- ) 
A17: brhs A18       ; ( k7 -- ) 
A18: brhc A19       ; ( k7 -- ) 
A19: brts A20       ; ( k7 -- ) 
A20: brtc A21       ; ( k7 -- ) 
A21: brvs A22       ; ( k7 -- ) 
A22: brvc A23       ; ( k7 -- ) 
A23: brie A24       ; ( k7 -- ) 
A24: brid A25       ; ( k7 -- ) 
A25:   nop 

; Data Transfer Instructions 
     mov   r0, r2       ; ( Rd Rr --   ) 
     movw  r0, r2       ; ( Rd Rr --   ) 
     ldi   r16, 1       ; ( Rd k8 --   ) 
     lds   r2, $FF00    ; ( Rd k16 --  ) 
     ld    r0, X        ; ( Rd Rr --   ) X 
     ld    r0, X+       ; ( Rd Rr --   ) 
     ld    r0, -X       ; ( Rd Rr --   ) 
     ld    r0, Y        ; ( Rd Rr --   ) Y 
     ld    r0, Y+       ; ( Rd Rr --   ) 
     ld    r0, -Y       ; ( Rd Rr --   ) 
     ldd   r4, Y+2      ; ( Rd Rr q -- ) Z 
     ld    r0, Z        ; ( Rd Rr --   ) 
     ld    r0, Z+       ; ( Rd Rr --   ) 
     ld    r0, -Z       ; ( Rd Rr --   ) 
     ldd   r4, Z+2      ; ( Rd Rr q -- ) 
     sts   $FF00, r2    ; ( k16 Rd --  ) 
     st    X, r3        ; ( Rd Rr --   ) X
     st    X+, r3       ; ( Rd Rr --   ) 
     st    -X, r3       ; ( Rd Rr --   ) 
     st    Y, r3        ; ( Rd Rr --   ) Y
     st    Y+, r3       ; ( Rd Rr --   ) 
     st    -Y, r3       ; ( Rd Rr --   ) 
     std   Y+2, r4      ; ( Rd q Rr -- ) 
     st    Z, r3        ; ( Rd Rr --   ) Z 
     st    Z+, r3       ; ( Rd Rr --   ) 
     st    -Z, r3       ; ( Rd Rr --   ) 
     std   Z+2, r4      ; ( Rd q Rr -- ) 
     lpm                ; ( -- ) 
     lpm   r16, Z       ; ( Rd Rr --   ) 
     lpm   r16, Z+      ; ( Rd Rr --   ) 
;     elpm               ; ( -- ) 
;     elpm  r16, Z       ; ( Rd Rr --   ) 
;     elpm  r16, Z+      ; ( Rd Rr --   ) 
     spm                ; ( -- ) Z <-- R1:R0
;     espm               ; ( -- ) ??? 
     in    r25, $16     ; ( Rd P -- ) 
     out   $18, r16     ; ( P Rr -- ) 
     push  r0           ; ( Rd -- ) 
     pop   r0           ; ( Rd -- ) 
;     elpm  ; ( -- ) 


; Bit and Bit-test Instructions 
     lsl   r0           ; ( Rd -- ) 
     lsr   r0           ; ( Rd -- ) 
     rol   r0           ; ( Rd -- ) 
     ror   r0           ; ( Rd -- ) 
     asr   r0           ; ( Rd -- ) 
     swap  r0           ; ( Rd -- ) 
     bset  7            ; ( bit# -- ) 
     bclr  7            ; ( bit# -- ) 
     sbi   $12,7        ; ( P b -- ) 
     cbi   $12,7        ; ( P b -- ) 
     bst   r0,4         ; ( Rd b -- ) 
     bld   r0,4         ; ( Rd b -- ) 

     sec    ; ( -- ) 
     clc    ; ( -- ) 
     sen    ; ( -- ) 
     cln    ; ( -- ) 
     sez    ; ( -- ) 
     clz    ; ( -- ) 
     sei    ; ( -- ) 
     cli    ; ( -- ) 
     ses    ; ( -- ) 
     cls    ; ( -- ) 
     sev    ; ( -- ) 
     clv    ; ( -- ) 
     set    ; ( -- ) 
     clt    ; ( -- ) 
     seh    ; ( -- ) 
     clh    ; ( -- ) 

; MCU Control Instructions 
     break  ; ( -- ) 
     nop    ; ( -- ) 
     sleep  ; ( -- ) 
     wdr    ; ( -- ) 


    .dw $5555,$5555,$5555,$5555,$5555 ; end sequence for idump 
PFA_ENDE0:

VE_ENDE:
    .db 4, "ende",0 
    .dw VE_HEAD
    .set VE_HEAD = VE_ENDE 
XT_ENDE:
    .dw PFA_DOVARIABLE
PFA_ENDE:
    .dw PFA_ENDE0



