
variable anfang2 
variable ende2   
here anfang2 ! 
5555 , 5555 , 5555 , 5555 , 5555 , \ ; starting sequence for idump 
hex

\ Arithmetic and Logic Insrtuctions  

R0 R2     add,  \ r0, r2       ; ( Rd Rr -- ) 5
R0 R2     adc,  \ r0, r2       ; ( Rd Rr -- ) 6
R24 1     adiw, \ r25:r24,1    ; ( Rw k6 -- ) 7
R0 R2     sub,  \ r0, r2       ; ( Rd Rr -- ) 8
R16 1     subi, \ r16, 1       ; ( Rd k8 -- ) 9
R0 R2     sbc,  \ r0, r2       ; ( Rd Rr -- ) 10
R16 1     sbci, \ r16, 1       ; ( Rd k8 -- ) 11
R24 1     sbiw, \ r25:r24,1    ; ( Rw k6 -- ) 12
R0 R2     and,  \ r0, r2       ; ( Rd Rr -- ) 13
R16 1     andi, \ r16, 1       ; ( Rd k8 -- ) 14
R0 R2     or,   \ r0, r2       ; ( Rd Rr -- ) 15
R16 1     ori,  \ r16, 1       ; ( Rd k8 -- ) 16
R0 R2     eor,  \ r0, r2       ; ( Rd Rr -- ) 17
R0        com,  \ r0           ; ( Rd --    ) 18
R0        neg,  \ r0           ; ( Rd --    ) 19
R16 1     sbr,  \ r16, 1       ; ( Rd k8 -- ) 20
R16 1     cbr,  \ r16, 1       ; ( Rd k8 -- ) 21
R0        inc,  \ r0           ; ( Rd --    ) 22
R0        dec,  \ r0           ; ( Rd --    ) 23
R0        tst,  \ r0           ; ( Rd --    ) 24
R0        clr,  \ r0           ; ( Rd --    ) 25
R16       ser,  \ r16          ; ( Rd --    ) 26
R16 R18     mul,  \ r16, r18    ; ( Rd Rr -- ) 27
R16 R18     muls,  \ r16, r18    ; ( Rd Rr -- ) 28
R16 R18     mulsu,  \ r16, r18    ; ( Rd Rr -- ) 29
R16 R18     fmul,   \ r16, r18    ; ( Rd Rr -- ) 30
R16 R18     fmuls,  \ r16, r18    ; ( Rd Rr -- ) 31
R16 R18     fmulsu, \ r16, r18    ; ( Rd Rr -- ) 32

\ Branch Instructions 
0    rjmp,    \ A1      ; ( k12 --    ) 33 k12 = $FFF = &4095 = 4K 
     ijmp,    \         ; ( -- ) 34
\     eijmp,  \         ; ( -- ) 35
\ k16 = $FFFF ; k6 = 3F max
\ together: $3FFFFF = &4194303 = 4MB 
FFFF 3F    jmp,   \ $3FFFFF ; ( k16 k6 -- ) 36
00    rcall,      \ A2      ; ( k12 --    ) 37 k12 = $FFF = &4095 = 4K 
      nop,        \         ; dummy for rcall 38
      icall,      \    ; ( -- ) 39
\     eicall,     \   ; ( -- ) 
FFFF 3F    call,  \  $3FFFFF ; ( k16 k6 -- ) 40 41
     ret,         \   ; ( -- ) 42
     reti,        \   ; ( -- ) 43
R0 R2     cpse,   \ r0, r2   ; ( Rd Rr -- ) 44
R0 R2     cp,     \ r0, r2   ; ( Rd Rr -- ) 45
R0 R2     cpc,    \ r0, r2   ; ( Rd Rr -- ) 46
R16 1     cpi,    \ r16, 1   ; ( Rd k8 -- ) 47
R0 7      sbrc,   \ r0,7     ; ( Rd b --  ) 48
R0 7      sbrs,   \ r0,7     ; ( Rd b --  ) 49
1C 1      sbic,   \ $1C, 1   ; ( P b --   ) 50
1C 1      sbis,   \ $1C, 1   ; ( P b --   ) 51
          nop,    \                         52
\ k7 = %1111111 = $7F max = &127 
\ opcode: 1111 01kk kkkk kbbb ; k=offset to PC, bbb=bit0..7 

0 1 brbs,       \ 1, A5    ; ( k7 b --  ) 53 caution: reverse stack order!
0 1 brbc,       \ 1, A6    ; ( k7 b --  ) 54 caution: reverse stack order!
     nop,        \                         55 
0  breq, \ A8        ; ( k7 -- ) 56
0  brne, \ A9        ; ( k7 -- ) 57
0  brcs, \ A10       ; ( k7 -- ) 58
0  brcc, \ A11       ; ( k7 -- ) 59
0  brsh, \ A12       ; ( k7 -- ) 60
0  brlo, \ A13       ; ( k7 -- ) 61
0  brmi, \ A14       ; ( k7 -- ) 62
0  brpl, \ A15       ; ( k7 -- ) 63
0  brge, \ A16       ; ( k7 -- ) 64
0  brlt, \ A17       ; ( k7 -- ) 65
0  brhs, \ A18       ; ( k7 -- ) 66
0  brhc, \ A19       ; ( k7 -- ) 67
0  brts, \ A20       ; ( k7 -- ) 68
0  brtc, \ A21       ; ( k7 -- ) 69
0  brvs, \ A22       ; ( k7 -- ) 70
0  brvc, \ A23       ; ( k7 -- ) 71
0  brie, \ A24       ; ( k7 -- ) 72
0  brid, \ A25       ; ( k7 -- ) 73
0   nop, \                       74

\ Data Transfer Instructions 
R0 R2     mov,   \ r0, r2    ; ( Rd Rr --   ) 75
R0 R2     movw,  \ r0, r2    ; ( Rd Rr --   ) 76
R16 1     ldi,   \ r16, 1    ; ( Rd k8 --   ) 77
R2 FF00   lds,   \ r2, $FF00 ; ( Rd k16 --  ) 78 79
R0 X     ld,  \ r0, X        ; ( Rd Rr --   ) X 80
R0 X+    ld,  \ r0, X+       ; ( Rd Rr --   ) 81
R0 -X    ld,  \ r0, -X       ; ( Rd Rr --   ) 82
R0 Y     ld,  \ r0, Y        ; ( Rd Rr --   ) Y 83
R0 Y+    ld,  \ r0, Y+       ; ( Rd Rr --   ) 84
R0 -Y    ld,  \ r0, -Y       ; ( Rd Rr --   ) 85
R4 Y 2   ldd, \ r4, Y+2      ; ( Rd Rr q -- ) Z 86   R4 !!
R0 Z     ld,  \ r0, Z        ; ( Rd Rr --   ) 87
R0 Z+    ld,  \ r0, Z+       ; ( Rd Rr --   ) 88
R0 -Z    ld,  \ r0, -Z       ; ( Rd Rr --   ) 89
R4 Z 2   ldd, \ r4, Z+2      ; ( Rd Rr q -- ) 90
FF00 R2  sts, \ $FF00, r2    ; ( k16 Rd --  ) 91 92
 X R3    st,  \ X, r3        ; ( Rr Rd --   ) 93  X
X+ R3    st,  \ X+, r3       ; ( Rr Rd --   ) 94
-X R3    st,  \ -X, r3       ; ( Rr Rd --   ) 95
 Y R3    st,  \ Y, r3        ; ( Rr Rd --   ) 96  Y
Y+ R3    st,  \ Y+, r3       ; ( Rr Rd --   ) 97
-Y R3    st,  \ -Y, r3       ; ( Rr Rd --   ) 98
 Y 2 R4  std, \ Y+2, r4      ; ( Rr q Rd -- ) 99
 Z R3   st,   \ Z, r3        ; ( Rr Rd --   ) 100  Z 
Z+ R3   st,   \ Z+, r3       ; ( Rr Rd --   ) 101
-Z R3   st,   \ -Z, r3       ; ( Rr Rd --   ) 102
Z 2 R4  std,  \ Z+2, r4      ; ( Rr q Rd -- ) 103
         lpm,   \            ; ( -- )         104
R16 Z    lpm_,  \ r16, Z     ; ( Rd Rr -- ) Rr={Z,Z+}  105
R16 Z+   lpm_,  \ r16, Z+    ; ( Rd Rr -- ) Rr={Z,Z+}  106
\          elpm,  \            ; ( -- ) 
\ R16 Z    elpm,  \ r16, Z     ; ( Rd Rr --   ) 
\ R16 Z+   elpm,  \ r16, Z+    ; ( Rd Rr --   ) 
         spm,   \            ; ( -- ) Z <-- R1:R0      107
\          espm,  \            ; ( -- ) ??? 
R25 16     in,  \ r25, $16   ; ( Rd P -- ) 108
18 R16     out, \ $18, r16   ; ( P Rr -- ) 109
R0       push,  \ r0         ; ( Rd -- ) 110
R0       pop,   \ r0         ; ( Rd -- ) 111
\         elpm,  \ ; ( -- ) 


\ Bit and Bit-test Instructions 
R0     lsl,  \ r0           ; ( Rd -- ) 112
R0     lsr,  \ r0           ; ( Rd -- ) 113
R0     rol,  \ r0           ; ( Rd -- ) 114
R0     ror,  \ r0           ; ( Rd -- ) 115
R0     asr,  \ r0           ; ( Rd -- ) 116
R0     swap,  \ r0           ; ( Rd -- ) 117
7     bset,   \ 7            ; ( bit# -- ) 118
7     bclr,   \ 7            ; ( bit# -- ) 119
12 7     sbi,  \ $12,7        ; ( P b -- ) 120
12 7     cbi,  \ $12,7        ; ( P b -- ) 121
R0 4     bst,  \ r0,4         ; ( Rd b -- ) 122
R0 4     bld,  \ r0,4         ; ( Rd b -- ) 123

     sec,  \ ; ( -- ) 124
     clc,  \ ; ( -- ) 125
     sen,  \ ; ( -- ) 126
     cln,  \ ; ( -- ) 127
     sez,  \ ; ( -- ) 128
     clz,  \ ; ( -- ) 129
     sei,  \ ; ( -- ) 130
     cli,  \ ; ( -- ) 131
     ses,  \ ; ( -- ) 132
     cls,  \ ; ( -- ) 133
     sev,  \ ; ( -- ) 134
     clv,  \ ; ( -- ) 135
     set,  \ ; ( -- ) 136
     clt,  \ ; ( -- ) 137
     seh,  \ ; ( -- ) 138
     clh,  \ ; ( -- ) 139

\ MCU Control Instructions 
     break,  \ ; ( -- ) 140
     nop,    \ ; ( -- ) 141
     sleep,  \ ; ( -- ) 142
     wdr,    \ ; ( -- ) 143

5555 , 5555 , 5555 , 5555 , 5555 , \ ; stop sequence for idump 
here ende2 ! 

cr ende2 @  anfang2 @ - .
cr ende     anfang    - .

: verification   
  ende anfang - 0
  do cr  decimal i . hex  
  ."  asm: " anfang      i + i@ dup 4 u.r
  ."  4th: " anfang2 @   i + i@ dup 4 u.r
  = if ."  ok" else ."  nok ***" then  
  loop ;

verify

